﻿using System;
using exMath.Calculus;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using exMath.Common;

namespace exMath.Test
{
    
    
    /// <summary>
    ///This is a test class for derivativeTest and is intended
    ///to contain all derivativeTest Unit Tests
    ///</summary>
    [TestClass()]
    public class derivativeTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Getderivative
        ///</summary>
        [TestMethod()]
        public void derivativeFunctionTest()
        {
             
            Derivative Sinderivative = new Derivative(Math.Sin);
            double x = Math.PI / 2.0;

            double result = Sinderivative.DerivativeFunction(x);
            Assert.AreEqual(Math.Cos(x), result);

            Derivative Lineairderivative = new Derivative(new MathFunction(delegate(double a) { return a; }));
            double LineairResult = Lineairderivative.DerivativeFunction(4.0);
            Assert.AreEqual(1.0, LineairResult);
            
            Derivative Squarederivative = new Derivative(BasicOperations.Square);
            double result2 = Squarederivative.DerivativeFunction(3.0);
            Assert.AreEqual(6.0, result2);
        }
    }
}
